function plant = getPlant(object)
% GETPLANT Returns the plant of an NCS object. 
%
%
% PLANT = GETPLANT(NCS) returns a structure containing the system matrices 
% of the plant in an NCS object where the plant dynamics are
%
%               \dot{x}= PLANT.A*x + PLANT.B*u
%                    y = PLANT.C*x
%
%   See also SETPLANT
%
% Copyright
% Copyright is with the following author(s):
%
% (C) 2012 Nick Bauer, Eindhoven University of Technology, The Netherlands, n.w.bauer@tue.nl
% (C) 2012 Bas van Loon, Eindhoven University of Technology, The Netherlands, s.j.l.m.v.Loon@tue.nl
% (C) 2012 Maurice Heemels, Eindhoven University of Technology, The Netherlands, m.heemels@tue.nl
% -------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% -------------------------------------------------------------------------
    plant.A=object.A;
    plant.B=object.B;
    plant.C=object.C;
    %SYS = ss(A,B,C,zeros(size(B,2),size(C,1)));
end