function r=findNextDropPoly(r0,ri)
%FINNEXTDROPPOLY determines a polygon in timing uncertainy space caused by
%                dropouts. 
%
%  R = FINNEXTDROPPOLY(R0,RI) uses the uncertainty polygon associated with zero 
%  drops, R0, and the polygon associated with the ith drop, RI, to determine 
%  the next polygon R.

    if size(r0,1)==1 %r0 is a point
        r(1,1) = r0(1,1) + ri(1,1); 
        r(1,2) = r0(1,2) + ri(1,2); 
    elseif size(r0,1)==2 % r0 is a vertical line
        r(1,1)=r0(1,1)+ri(1,1); %add h component
        r(2,1)=r0(2,1)+ri(2,1); %add h component
        r(1,2)=r0(1,2);
        r(2,2)=r0(2,2);
    else            %r0 is a polygon
        marker=1;
        for verts=1:length(ri)
          for verts2=1:length(r0)
             p1(marker,1)=ri(verts,1)+r0(verts2,1);
             p2(marker,1)=ri(verts,1)+r0(verts2,1);

             p1(marker,2)=ri(verts,2);
             p2(marker,2)=r0(verts2,2);
             marker=marker+1;
          end
        end

        P=[p1;p2];
        k=convhull(P(:,1),P(:,2));
        r=P(k,:);
    end
end