function varargout = ncsAnalyzer(varargin)
% Copyright
% Copyright is with the following author(s):
%
% (C) 2012 Nick Bauer, Eindhoven University of Technology, The Netherlands, n.w.bauer@tue.nl
% (C) 2012 Bas van Loon, Eindhoven University of Technology, The Netherlands, s.j.l.m.v.Loon@tue.nl
% (C) 2012 Maurice Heemels, Eindhoven University of Technology, The Netherlands, m.heemels@tue.nl
% -------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% -------------------------------------------------------------------------

% Edit the above text to modify the response to help ncsAnalyzer

% Last Modified by GUIDE v2.5 05-Nov-2013 16:35:50

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ncsAnalyzer_OpeningFcn, ...
                   'gui_OutputFcn',  @ncsAnalyzer_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT




% --- Executes just before ncsAnalyzer is made visible.
function ncsAnalyzer_OpeningFcn(hObject, eventdata, handles, varargin) %#ok<*INUSL>
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ncsAnalyzer (see VARARGIN)

    handles.ncsEditor = varargin{1};
    handles.ncs = varargin{2};
% Obtain handles using GUIDATA with the caller's handle 
%mainHandles = guidata(handles.ncsEditor);

% Choose default command line output for ncsAnalyzer
    handles.output = hObject;

    if strcmp(handles.ncs.getController.ctrlType,'D-LTI Dynamic Feedback') || ...
            strcmp(handles.ncs.getController.ctrlType,'D-LTI Observer-Based Feedback')
        set(handles.MatiMadButton,'Enable','off')
        set(handles.HYBradio,'Enable','off')
    end
    
    if isempty(handles.ncs.getNetwork.timingDist) || strcmp(handles.ncs.getNetwork.protocol,'TOD') 
        set(handles.stochRadio,'Enable','off')
        set(handles.text182,'Enable','off')
        set(handles.stochStabResult,'Enable','off')
    end    
    
% Position to be relative to parent:
% parentPosition = getpixelposition(handles.ncsEditor);
% currentPosition = get(hObject, 'Position');  
% Sets the position to be directly centered on the main figure
% newX = parentPosition(1)+ round(parentPosition(3)/2 );
% newY = parentPosition(2)+ round(parentPosition(4)/2);
% newW = currentPosition(3);
% newH = currentPosition(4);
% 
% %msgbox([num2str(newX) ',  ' num2str(newY) ',  ' num2str(newW) ',  ' num2str(newH)])
% 
% set(hObject, 'Position', [newX, newY, newW, newH]);

% Update handles structure
    guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = ncsAnalyzer_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
    varargout{1} = handles.output;
%    delete(hObject);

% --- Executes on selection change in popupmenu13.
function popupmenu13_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu13 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu13


% --- Executes during object creation, after setting all properties.
function popupmenu13_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit31_Callback(hObject, eventdata, handles)
% hObject    handle to edit31 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit31 as text
%        str2double(get(hObject,'String')) returns contents of edit31 as a double


% --- Executes during object creation, after setting all properties.
function edit31_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit31 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu14.
function popupmenu14_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu14 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu14


% --- Executes during object creation, after setting all properties.
function popupmenu14_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu15.
function popupmenu15_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu15 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu15


% --- Executes during object creation, after setting all properties.
function popupmenu15_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function JnfGamma_Callback(hObject, eventdata, handles)
% hObject    handle to JnfGamma (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of JnfGamma as text
%        str2double(get(hObject,'String')) returns contents of JnfGamma as a double


function edit34_Callback(hObject, eventdata, handles)
% hObject    handle to edit34 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit34 as text
%        str2double(get(hObject,'String')) returns contents of edit34 as a double


% --- Executes during object creation, after setting all properties.
function edit34_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit34 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function GnbMaxGpts_Callback(hObject, eventdata, handles)
% hObject    handle to GnbMaxGpts (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of GnbMaxGpts as text
%        str2double(get(hObject,'String')) returns contents of GnbMaxGpts as a double


% --- Executes during object creation, after setting all properties.
function GnbMaxGpts_CreateFcn(hObject, eventdata, handles)
% hObject    handle to GnbMaxGpts (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function GnbTightness_Callback(hObject, eventdata, handles)
% hObject    handle to GnbTightness (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of GnbTightness as text
%        str2double(get(hObject,'String')) returns contents of GnbTightness as a double


% --- Executes during object creation, after setting all properties.
function GnbTightness_CreateFcn(hObject, eventdata, handles)
% hObject    handle to GnbTightness (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in GnbUwired.
function GnbUwired_Callback(hObject, eventdata, handles)
% hObject    handle to GnbUwired (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns GnbUwired contents as cell array
%        contents{get(hObject,'Value')} returns selected item from GnbUwired


% --- Executes during object creation, after setting all properties.
function GnbUwired_CreateFcn(hObject, eventdata, handles)
% hObject    handle to GnbUwired (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in StabilityButton.
function StabilityButton_Callback(hObject, eventdata, handles)
% hObject    handle to StabilityButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    set(hObject,'Enable','off');
    set(handles.VerticesButton,'Enable','off');
    set(handles.MatiMadButton,'Enable','off');
    drawnow;

    if get(handles.JNFradio,'Value') == 1    

        [stable,verts] = handles.ncs.isNcsStable('JNF',[]);

        numVerts= size(verts.Ab,2);
        set(handles.JnfVerts,'String',num2str(numVerts));
        if stable ==1 
            set(handles.JnfStabResult,'String','Guaranteed')
            set(handles.JnfStabResult,'ForegroundColor','green')
        else
            set(handles.JnfStabResult,'String','Not Guaranteed')
            set(handles.JnfStabResult,'ForegroundColor','red')    
        end

    elseif get(handles.CHradio,'Value') == 1


        [stable,verts] = handles.ncs.isNcsStable('CH',[]);

        numVerts= size(verts.Ab,2);
        set(handles.ChVerts,'String',num2str(numVerts));
        if stable ==1 
            set(handles.ChStabResult,'String','Guaranteed')
            set(handles.ChStabResult,'ForegroundColor','green')
        else
            set(handles.ChStabResult,'String','Not Guaranteed')
            set(handles.ChStabResult,'ForegroundColor','red')    
        end

    elseif get(handles.GNBradio,'Value') == 1

        MaxGpts = get(handles.GnbMaxGpts,'String');
        tightness = get(handles.GnbTightness,'String');

        [stable,verts] = handles.ncs.isNcsStable('GNB',[],str2double(tightness),str2double(MaxGpts));

        numVerts= size(verts.Ab,2);
        set(handles.GnbVerts,'String',num2str(numVerts));
        set(handles.GnbTightResult,'String',num2str(verts.MaxEps));

        if stable ==1 
            set(handles.GnbStabResult,'String','Guaranteed')
            set(handles.GnbStabResult,'ForegroundColor','green')
        else
            set(handles.GnbStabResult,'String','Not Guaranteed')
            set(handles.GnbStabResult,'ForegroundColor','red')    
        end
    elseif get(handles.stochRadio,'Value') == 1
        
        stable = handles.ncs.isNcsStable('STOCH');
        if stable ==1 
            set(handles.stochStabResult,'String','Guaranteed')
            set(handles.stochStabResult,'ForegroundColor','green')
        else
            set(handles.stochStabResult,'String','Not Guaranteed')
            set(handles.stochStabResult,'ForegroundColor','red')    
        end        
    end

    set(hObject,'Enable','on');
    set(handles.VerticesButton,'Enable','on');
    if strcmp(handles.ncs.getController.ctrlType,'D-LTI Dynamic Feedback')
        set(handles.MatiMadButton,'Enable','off');
    else
        set(handles.MatiMadButton,'Enable','on');
    end


% --- Executes on selection change in JnfLyapType.
function JnfLyapType_Callback(hObject, eventdata, handles)
% hObject    handle to JnfLyapType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns JnfLyapType contents as cell array
%        contents{get(hObject,'Value')} returns selected item from JnfLyapType


% --- Executes during object creation, after setting all properties.
function JnfLyapType_CreateFcn(hObject, eventdata, handles)
% hObject    handle to JnfLyapType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ChGamma_Callback(hObject, eventdata, handles)
% hObject    handle to ChGamma (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ChGamma as text
%        str2double(get(hObject,'String')) returns contents of ChGamma as a double


% --- Executes during object creation, after setting all properties.
function ChGamma_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ChGamma (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in ChLyapType.
function ChLyapType_Callback(hObject, eventdata, handles)
% hObject    handle to ChLyapType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns ChLyapType contents as cell array
%        contents{get(hObject,'Value')} returns selected item from ChLyapType


% --- Executes during object creation, after setting all properties.
function ChLyapType_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ChLyapType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when user attempts to close ncsAnalyzer.
function ncsAnalyzer_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to ncsAnalyzer (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
set(handles.ncsEditor,'Visible','on');
delete(hObject);

% --- Executes during object deletion, before destroying properties.
function uipanel3_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to uipanel3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object deletion, before destroying properties.
function ncsAnalyzer_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to ncsAnalyzer (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function uipanel3_CreateFcn(hObject, eventdata, handles) %#ok<*INUSD,*DEFNU>
% hObject    handle to uipanel3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function ncsAnalyzer_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ncsAnalyzer (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in VerticesButton.
function VerticesButton_Callback(hObject, eventdata, handles)
% hObject    handle to VerticesButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    set(hObject,'Enable','off');
    set(handles.StabilityButton,'Enable','off');
    set(handles.MatiMadButton,'Enable','off');
    drawnow;

    if get(handles.JNFradio,'Value')==1
        ovrAprx = handles.ncs.getPolyOvrAprx('JNF');
        assignin('base', 'ovrAprxJNF', ovrAprx);
    elseif get(handles.CHradio,'Value')==1
        ovrAprx = handles.ncs.getPolyOvrAprx('CH');
        assignin('base', 'ovrAprxCH', ovrAprx);
    elseif get(handles.GNBradio,'Value')==1

        MaxGpts = get(handles.GnbMaxGpts,'String');
        tightness = get(handles.GnbTightness,'String');

        ovrAprx = handles.ncs.getPolyOvrAprx('GNB',str2double(tightness),str2double(MaxGpts));
        assignin('base', 'ovrAprxGNB', ovrAprx);
    end

    set(hObject,'Enable','on');
    set(handles.StabilityButton,'Enable','on');
    set(handles.MatiMadButton,'Enable','on');


% --- Executes when selected object is changed in uipanel3.
function uipanel3_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel3 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

    if get(handles.JNFradio,'Value')==1
        set(handles.VerticesButton,'Enable','on');
        set(handles.GnbMaxGpts,'Enable','off');
        set(handles.GnbTightness,'Enable','off');
    elseif get(handles.CHradio,'Value')==1
        set(handles.VerticesButton,'Enable','on');
        set(handles.GnbMaxGpts,'Enable','off');
        set(handles.GnbTightness,'Enable','off');
    elseif get(handles.GNBradio,'Value')==1
        set(handles.VerticesButton,'Enable','on');
        set(handles.GnbMaxGpts,'Enable','on');
        set(handles.GnbTightness,'Enable','on');
    elseif get(handles.stochRadio,'Value')==1
        set(handles.VerticesButton,'Enable','off');
        set(handles.GnbMaxGpts,'Enable','off');
        set(handles.GnbTightness,'Enable','off');       
    end


% --- Executes on button press in MatiMadButton.
function MatiMadButton_Callback(hObject, eventdata, handles)
% hObject    handle to MatiMadButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    handles.ncs.findMatiMadBoundry(1);
    
    
% --- Executes on button press in backButton.
function backButton_Callback(hObject, eventdata, handles)
% hObject    handle to backButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    ncsAnalyzer_CloseRequestFcn(handles.ncsAnalyzer, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function JNFradio_CreateFcn(hObject, eventdata, handles)
% hObject    handle to JNFradio (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
