function varargout = ncsSimulator(varargin)
% Copyright
% Copyright is with the following author(s):
%
% (C) 2012 Nick Bauer, Eindhoven University of Technology, The Netherlands, n.w.bauer@tue.nl
% (C) 2012 Bas van Loon, Eindhoven University of Technology, The Netherlands, s.j.l.m.v.Loon@tue.nl
% (C) 2012 Maurice Heemels, Eindhoven University of Technology, The Netherlands, m.heemels@tue.nl
% -------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% -------------------------------------------------------------------------
% Edit the above text to modify the response to help ncsSimulator

% Last Modified by GUIDE v2.5 30-Sep-2013 11:59:57

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ncsSimulator_OpeningFcn, ...
                   'gui_OutputFcn',  @ncsSimulator_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT




% --- Executes just before ncsSimulator is made visible.
function ncsSimulator_OpeningFcn(hObject, eventdata, handles, varargin) %#ok<*INUSL>
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ncsSimulator (see VARARGIN)

    handles.ncsEditor = varargin{1};
    handles.ncs = varargin{2};
% Obtain handles using GUIDATA with the caller's handle 
%mainHandles = guidata(handles.ncsEditor);

% Choose default command line output for ncsSimulator
    handles.output = hObject;

            
% Position to be relative to parent:
% parentPosition = getpixelposition(handles.ncsEditor);
% currentPosition = get(hObject, 'Position');  
% Sets the position to be directly centered on the main figure
% newX = parentPosition(1)+ round(parentPosition(3)/2 );
% newY = parentPosition(2)+ round(parentPosition(4)/2);
% newW = currentPosition(3);
% newH = currentPosition(4);
% 
% %msgbox([num2str(newX) ',  ' num2str(newY) ',  ' num2str(newW) ',  ' num2str(newH)])
% 
% set(hObject, 'Position', [newX, newY, newW, newH]);

    % Update handles structure
    guidata(hObject, handles);

    P=handles.ncs.getPlant;
    np=size(P.A,1);
    nu=size(P.B,2);
    ny=size(P.C,1);
    
    strOut='[';
    for ctr=1:np
        strOut=strcat(strOut,' 1');
    end
    strOut=strcat(strOut,' ]');
    set(handles.xp0,'String',strOut);
    
    C=handles.ncs.getController;
    if ~strcmp(C.ctrlType,'Static Feedback')
        nc=size(C.A{1},1);
        strOut='[';
        for ctr=1:nc
            strOut=strcat(strOut,' 0');
        end
        strOut=strcat(strOut,' ]');
        set(handles.xc0,'String',strOut);
    else
        set(handles.xc0,'String','N/A');
        set(handles.xc0,'Enable','off');
    end

    if ~strcmp(C.ctrlType,'C-LTI Dynamic Feedback (uWired)')
        strOut='[';
        for ctr=1:nu
            strOut=strcat(strOut,' 0');
        end
        strOut=strcat(strOut,' ]');
        set(handles.eu0,'String',strOut);
    else
        set(handles.eu0,'String','N/A');
        set(handles.eu0,'Enable','off');
    end
    
    strOut='[';
    for ctr=1:ny
        strOut=strcat(strOut,' 0');
    end
    strOut=strcat(strOut,' ]');
    set(handles.ey0,'String',strOut);
    
    Tsec = str2double(get(handles.T,'String'));
    net=handles.ncs.getNetwork();
    T=ceil(Tsec/((net.txIntvls(2)+net.txIntvls(1))/2));
    set(handles.stepsApproxText,'String',['(~' num2str(T) ' steps)'])
    
    
    
% --- Outputs from this function are returned to the command line.
function varargout = ncsSimulator_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
    varargout{1} = handles.output;
%    delete(hObject);

function SimulateButton_Callback(hObject, eventdata, handles)
% hObject    handle to SimulateButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    %set(hObject,'Enable','off');
    drawnow;
    
    xp0=evalin('base',get(handles.xp0,'String'));
    if strcmp(handles.ncs.getController.ctrlType,'C-LTI Dynamic Feedback (uWired)')
       eu0=[]; 
    else
        eu0=evalin('base',get(handles.eu0,'String'));
    end
    
    ey0=evalin('base',get(handles.ey0,'String'));
    
    if strcmp(handles.ncs.getController.ctrlType,'Static Feedback')
        xc0=[];
    else
        xc0=evalin('base',get(handles.xc0,'String'));
    end
        
    if get(handles.randomSeqRadio,'Value') == 1    
        T  =evalin('base',get(handles.T,'String'));
        dropProb  =evalin('base',get(handles.dropProb,'String'));
        handles.ncs.simulateNcs([xp0 xc0 eu0 ey0],T,0.01*dropProb);
    elseif get(handles.customSeqRadio,'Value') == 1    
        txIntvls = evalin('base',get(handles.txIntvl_custom,'String'));
        delay    = evalin('base',get(handles.delay_custom,'String'));
        node     = evalin('base',get(handles.node_custom,'String'));
        
        if any(delay>txIntvls)
            msgbox('Custom txIntvl and delay sequences do not satisfy the small-delay assumption','NCS Toolbox Error','error')
            return;
        elseif any(node>length(handles.ncs.getNetwork.gammaU))
            msgbox('Custom node sequence indexes nodes which are not defined.','NCS Toolbox Error','error')
            return;
        end
        
        handles.ncs.simulateNcs([xp0 xc0 eu0 ey0],txIntvls,delay,node);
    end
    %handles.ncs.simulateNcs;
    set(hObject,'Enable','on');
    

% --- Executes when user attempts to close ncsSimulator.
function ncsSimulator_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to ncsSimulator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
set(handles.ncsEditor,'Visible','on');
delete(hObject);

% --- Executes during object deletion, before destroying properties.
function uipanel3_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to uipanel3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object deletion, before destroying properties.
function ncsSimulator_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to ncsSimulator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function uipanel3_CreateFcn(hObject, eventdata, handles) %#ok<*INUSD,*DEFNU>
% hObject    handle to uipanel3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function ncsSimulator_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ncsSimulator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes when selected object is changed in uipanel3.
function uipanel3_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel3 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)


    
% --- Executes on button press in backButton.
function backButton_Callback(hObject, eventdata, handles)
% hObject    handle to backButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    ncsSimulator_CloseRequestFcn(handles.ncsSimulator, eventdata, handles)



function xc0_Callback(hObject, eventdata, handles)
% hObject    handle to xc0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of xc0 as text
%        str2double(get(hObject,'String')) returns contents of xc0 as a double


% --- Executes during object creation, after setting all properties.
function xc0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to xc0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
    
function eu0_Callback(hObject, eventdata, handles)
% hObject    handle to eu0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of eu0 as text
%        str2double(get(hObject,'String')) returns contents of eu0 as a double


% --- Executes during object creation, after setting all properties.
function eu0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to eu0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ey0_Callback(hObject, eventdata, handles)
% hObject    handle to ey0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ey0 as text
%        str2double(get(hObject,'String')) returns contents of ey0 as a double


% --- Executes during object creation, after setting all properties.
function ey0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ey0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txIntvl_custom_Callback(hObject, eventdata, handles)
% hObject    handle to txIntvl_custom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txIntvl_custom as text
%        str2double(get(hObject,'String')) returns contents of txIntvl_custom as a double


% --- Executes during object creation, after setting all properties.
function txIntvl_custom_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txIntvl_custom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function delay_custom_Callback(hObject, eventdata, handles)
% hObject    handle to delay_custom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of delay_custom as text
%        str2double(get(hObject,'String')) returns contents of delay_custom as a double


% --- Executes during object creation, after setting all properties.
function delay_custom_CreateFcn(hObject, eventdata, handles)
% hObject    handle to delay_custom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function node_custom_Callback(hObject, eventdata, handles)
% hObject    handle to node_custom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of node_custom as text
%        str2double(get(hObject,'String')) returns contents of node_custom as a double


% --- Executes during object creation, after setting all properties.
function node_custom_CreateFcn(hObject, eventdata, handles)
% hObject    handle to node_custom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function T_Callback(hObject, eventdata, handles)
% hObject    handle to T (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of T as text
%        str2double(get(hObject,'String')) returns contents of T as a double
Tsec = str2double(get(hObject,'String'));
net=handles.ncs.getNetwork();
T=ceil(Tsec/((net.txIntvls(2)+net.txIntvls(1))/2));
set(handles.stepsApproxText,'String',['(~' num2str(T) ' steps)']);

% --- Executes during object creation, after setting all properties.
function T_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function xp0_Callback(hObject, eventdata, handles)
% hObject    handle to xp0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of xp0 as text
%        str2double(get(hObject,'String')) returns contents of xp0 as a double


% --- Executes during object creation, after setting all properties.
function xp0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to xp0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when selected object is changed in uipanel18.
function uipanel18_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel18 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)


if get(handles.randomSeqRadio,'Value')==1
    set(handles.T,'Enable','on');
    set(handles.txIntvl_custom,'Enable','off');
    set(handles.delay_custom,'Enable','off');
    set(handles.node_custom,'Enable','off');
elseif get(handles.customSeqRadio,'Value')==1
    set(handles.T,'Enable','off');
    set(handles.txIntvl_custom,'Enable','on');
    set(handles.delay_custom,'Enable','on');
    set(handles.node_custom,'Enable','on');
end


% --- Executes on key press with focus on T and none of its controls.
function T_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to T (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)



function dropProb_Callback(hObject, eventdata, handles)
% hObject    handle to dropProb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dropProb as text
%        str2double(get(hObject,'String')) returns contents of dropProb as a double


% --- Executes during object creation, after setting all properties.
function dropProb_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dropProb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
