function varargout = nodes(varargin)
% Copyright
% Copyright is with the following author(s):
%
% (C) 2012 Nick Bauer, Eindhoven University of Technology, The Netherlands, n.w.bauer@tue.nl
% (C) 2012 Bas van Loon, Eindhoven University of Technology, The Netherlands, s.j.l.m.v.Loon@tue.nl
% (C) 2012 Maurice Heemels, Eindhoven University of Technology, The Netherlands, m.heemels@tue.nl
% -------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% -------------------------------------------------------------------------

% Edit the above text to modify the response to help nodes

% Last Modified by GUIDE v2.5 25-Apr-2012 10:18:52

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @nodes_OpeningFcn, ...
                   'gui_OutputFcn',  @nodes_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before nodes is made visible.
function nodes_OpeningFcn(hObject, eventdata, handles, varargin) %#ok<*INUSL>
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to nodes (see VARARGIN)

% Choose default command line output for nodes
% handles.output = hObject;

%mainGuiInput = find(strcmp(varargin, 'ncsEditor'));
% Remember the handle, and adjust our position
    handles.ncsEditor = varargin{1};

    % Obtain handles using GUIDATA with the caller's handle 
    mainHandles = guidata(handles.ncsEditor);

    %------------------------------
    % Set the text equal to the main GUI's text box
    set(handles.allNodesList, 'String',get(mainHandles.nodeList, 'String'));    

    %------------------------------
    % Add inputs and outputs according to the size of the plant matrices

    if get(mainHandles.uWiredCheckBox,'Value') == 0
        numInputs = size(evalin('base',char(get(mainHandles.B,'String'))),2);
    else
        numInputs = 0;
    end
    numOutputs = size(evalin('base',char(get(mainHandles.C,'String'))),1);

    list = cell(1,numInputs+numOutputs);

    for ctr = 1:numInputs
        if ctr <= 9
            list{ctr} = strcat('u0',num2str(ctr));
        else
            list{ctr} = strcat('u',num2str(ctr));
        end
    end

    for ctr = 1:numOutputs
        if ctr <= 9
            list{numInputs+ctr} = strcat('y0',num2str(ctr));
        else
            list{numInputs+ctr} = strcat('y',num2str(ctr));
        end
    end

    set(handles.inputOutputList,'String',list);

    %------------------------------
    % initialize the node list according to the definition of node1
    singleNodeList = get(mainHandles.nodeList,'String');

    if isempty(singleNodeList{1}(11:end)) == 0
        data=textscan(singleNodeList{1}(11:end),'%s','delimiter',',');
    else
        data{1} = '';
    end
    set(handles.singleNodeList,'String',data{1});


    % Update handles structure
    guidata(hObject, handles);
    % UIWAIT makes nodes wait for user response (see UIRESUME)
    uiwait(handles.nodeGui);


% --- Outputs from this function are returned to the command line.
function varargout = nodes_OutputFcn(hObject, eventdata, handles)  %#ok<*INUSD>
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = [];
delete(hObject);


% --- Executes on selection change in inputOutputList.
function inputOutputList_Callback(hObject, eventdata, handles) %#ok<*DEFNU>
% hObject    handle to inputOutputList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns inputOutputList contents as cell array
%        contents{get(hObject,'Value')} returns selected item from inputOutputList


% --- Executes during object creation, after setting all properties.
function inputOutputList_CreateFcn(hObject, eventdata, handles)
% hObject    handle to inputOutputList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in singleNodeList.
function singleNodeList_Callback(hObject, eventdata, handles)
% hObject    handle to singleNodeList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns singleNodeList contents as cell array
%        contents{get(hObject,'Value')} returns selected item from singleNodeList


% --- Executes during object creation, after setting all properties.
function singleNodeList_CreateFcn(hObject, eventdata, handles)
% hObject    handle to singleNodeList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in AddInOut.
function AddInOut_Callback(hObject, eventdata, handles)
% hObject    handle to AddInOut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    inOutList = get(handles.inputOutputList,'String'); 
    numSelected = get(handles.inputOutputList,'Value');

    allNodesList = get(handles.allNodesList,'String'); 
    nodeSelected = get(handles.allNodesList,'Value');


    inOutNode = get(handles.singleNodeList,'String'); 

    if isempty(inOutNode)
        inOutNode{1} = inOutList{numSelected}; 
        set(handles.singleNodeList,'String',inOutNode);
        set(handles.singleNodeList,'Value',1)
        allNodesList{nodeSelected} = [allNodesList{nodeSelected}(1:10) inOutNode{1}];
        set(handles.allNodesList,'String',allNodesList);
        return
    end

    %check if there is a copy already on list
    okToAdd = 1;
    for ctr = 1:length(inOutNode)
       if strcmp(inOutList{numSelected},inOutNode{ctr});
          okToAdd = 0; 
       end
    end

    if okToAdd == 1
        inOutNode{end+1} = inOutList{numSelected};

        inOutNode = sort(inOutNode);
        set(handles.singleNodeList,'String',inOutNode);
        finalStr='';
        for ctr =1:length(inOutNode)-1
            finalStr = [finalStr inOutNode{ctr} ',']; %#ok<AGROW>
        end
        finalStr = [finalStr inOutNode{ctr+1}];

        allNodesList{nodeSelected} = [allNodesList{nodeSelected}(1:10) finalStr];
        set(handles.allNodesList,'String',allNodesList);
    end

    if numSelected ~= length(inOutList)
        set(handles.inputOutputList,'Value',numSelected+1);
    end

% --- Executes on button press in RemoveInOut.
function RemoveInOut_Callback(hObject, eventdata, handles)
% hObject    handle to RemoveInOut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    contents = get(handles.singleNodeList,'String'); 

     if length(contents) == 1
         msgbox('Must be one input or output in a node','NCS Toolbox Error')
     elseif length(contents) > 1
        allNodesList = get(handles.allNodesList,'String'); 
        nodeSelected = get(handles.allNodesList,'Value');

        numSelected = get(handles.singleNodeList,'Value');
        contents{numSelected}= '';
        contents(cellfun(@isempty,contents)) = '';
        set(handles.singleNodeList,'String',contents);
        set(handles.singleNodeList,'Value',length(contents))
        finalStr='';

        if length(contents) > 1
            for ctr =1:length(contents)-1
                finalStr = [finalStr contents{ctr} ',']; %#ok<AGROW>
            end
            finalStr = [finalStr contents{ctr+1}];
        else
            finalStr = contents{1};
        end


        allNodesList{nodeSelected} = [allNodesList{nodeSelected}(1:10) finalStr];
        set(handles.allNodesList,'String',allNodesList);
     end


% --- Executes on button press in OkButton.
function OkButton_Callback(hObject, eventdata, handles)
% hObject    handle to OkButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    main = handles.ncsEditor;
    mainHandles = guidata(main);
    set(mainHandles.nodeList,'String',get(handles.allNodesList,'String'));
    contents = get(handles.allNodesList,'String'); 

    nodeString = cell(1,length(contents));
    for ctr = 1:length(contents)
       nodeString{ctr} = num2str(ctr); 
    end

    set(mainHandles.ctlNodeSelect,'String',nodeString)
    uiresume(handles.nodeGui);

% --- Executes during object creation, after setting all properties.
function nodeGui_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nodeGui (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on selection change in allNodesList.
function allNodesList_Callback(hObject, eventdata, handles)
% hObject    handle to allNodesList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns allNodesList contents as cell array
%        contents{get(hObject,'Value')} returns selected item from allNodesList

    singleNodeList = get(hObject,'String');
    numSelected = get(hObject,'Value');

    if isempty(singleNodeList{numSelected}(11:end)) == 0
        data=textscan(singleNodeList{numSelected}(11:end),'%s','delimiter',',');
    else
        data{1} = '';
    end
    set(handles.singleNodeList,'String',data{1});
    set(handles.nodeText,'String',['Node: ' singleNodeList{numSelected}(5:6)])

% --- Executes during object creation, after setting all properties.
function allNodesList_CreateFcn(hObject, eventdata, handles)
% hObject    handle to allNodesList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'FontName','FixedWidth');


% --- Executes on button press in AddButton.
function AddButton_Callback(hObject, eventdata, handles)
% hObject    handle to AddButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    contents = get(handles.allNodesList,'String');
    if length(contents) <= 8
        contents{end+1} = ['node' num2str(length(contents)+1) '     '];
    else
        contents{end+1} = ['node' num2str(length(contents)+1) '    '];
    end

    set(handles.allNodesList,'String',contents);
    set(handles.allNodesList,'Value',length(contents));
    set(handles.singleNodeList,'String','');
    %set(handles.nodeText,'String',['Node: ' num2str(length(contents))])
    allNodesList_Callback(handles.allNodesList, eventdata, handles)
    
% --- Executes on button press in DeleteButton.
function DeleteButton_Callback(hObject, eventdata, handles)
% hObject    handle to DeleteButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    contents = get(handles.allNodesList,'String');

    if length(contents) == 1
        msgbox('Cannot delete, must have one node defined','NCS Toolbox Error')
        return
    end

    numSelected = get(handles.allNodesList,'Value');

    contents{numSelected}= '';
    contents(cellfun(@isempty,contents)) = '';

    for ctr = numSelected:length(contents)
        contents{ctr} = ['node' num2str(ctr) contents{ctr}(6:end)];
    end
    if numSelected > length(contents)
        set(handles.allNodesList,'Value',length(contents))
        %set(handles.nodeText,'String',['Node: ' num2str(length(contents))])
    end
    set(handles.allNodesList,'String',contents);
    allNodesList_Callback(handles.allNodesList, eventdata, handles)
    
% --- Executes on button press in moveUpButton.
function moveUpButton_Callback(hObject, eventdata, handles)
% hObject    handle to moveUpButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    contents = get(handles.allNodesList,'String');
    numSelected = get(handles.allNodesList,'Value');
    if numSelected ~= 1
        tempSave = contents{numSelected-1}(11:end);
        contents{numSelected-1} = [contents{numSelected-1}(1:10) contents{numSelected}(11:end)];
        contents{numSelected} = [contents{numSelected}(1:10) tempSave];
        set(handles.allNodesList,'String',contents)
        set(handles.allNodesList,'Value',numSelected-1)
       % set(handles.nodeText,'String',['Node: ' num2str(numSelected-1)])
    end
    allNodesList_Callback(handles.allNodesList, eventdata, handles)
    
% --- Executes on button press in MoveDownButton.
function MoveDownButton_Callback(hObject, eventdata, handles)
% hObject    handle to MoveDownButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    contents = get(handles.allNodesList,'String');
    numSelected = get(handles.allNodesList,'Value');
    if numSelected ~= length(contents)
        tempSave = contents{numSelected}(11:end);
        contents{numSelected} = [contents{numSelected}(1:10) contents{numSelected+1}(11:end)];
        contents{numSelected+1} = [contents{numSelected+1}(1:10) tempSave];
        set(handles.allNodesList,'String',contents)
        set(handles.allNodesList,'Value',numSelected+1)
        set(handles.nodeText,'String',['Node: ' num2str(numSelected+1)])
    end


% --- Executes on button press in cancelButton.
function cancelButton_Callback(hObject, eventdata, handles)
% hObject    handle to cancelButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

uiresume(handles.nodeGui);


% --- Executes when user attempts to close nodeGui.
function nodeGui_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to nodeGui (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

uiresume(hObject);


% --- Executes during object creation, after setting all properties.
function AddInOut_CreateFcn(hObject, eventdata, handles)
% hObject    handle to AddInOut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function nodeText_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nodeText (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
set(hObject,'String','Node: 1')


% --- Executes on key press with focus on singleNodeList and none of its controls.
function singleNodeList_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to singleNodeList (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
